/**
 * Gets the application version.
 * @example
 * ```typescript
 * import { getVersion } from '@tauri-apps/api/app';
 * const appVersion = await getVersion();
 * ```
 *
 * @returns A promise resolving to the application version.
 */
declare function getVersion(): Promise<string>;
/**
 * Gets the application name.
 * @example
 * ```typescript
 * import { getName } from '@tauri-apps/api/app';
 * const appName = await getName();
 * ```
 *
 * @returns A promise resolving to application name.
 */
declare function getName(): Promise<string>;
/**
 * Gets the tauri version.
 *
 * @example
 * ```typescript
 * import { getTauriVersion } from '@tauri-apps/api/app';
 * const tauriVersion = await getTauriVersion();
 * ```
 *
 * @returns A promise resolving to tauri version.
 */
declare function getTauriVersion(): Promise<string>;
export { getName, getVersion, getTauriVersion };
